local colours = {
		{"black", "Black"},
		{"bulbgreen", "Bulb Green"},
		{"bulbgreen2", "Bulb Green 2"},
		{"bulbgrey", "Bulb Grey"},
		{"bulbpurple", "Bulb Purple"},
		{"candlegreen", "Candle Green"},
		{"candlepink", "Candle Pink"},
		{"candlepurple", "Candle Purple"},
		{"candlered", "Candle Red"},
		{"cookie", "Cookie"},
		{"cyan", "Cyan"},
		{"brown", "Brown"},
		{"dark_blue", "Dark Blue"},
		{"dark_green", "Dark Green"},
		{"dark_grey", "Dark Grey"},
		{"dark_pink", "Dark Pink"},
		{"green", "Green"},
		{"grey", "Grey"},
		{"nutcracker", "Nutcracker"},
		{"orange", "Orange"},
		{"pattern", "Pattern"},
		{"pink", "Pink"},
		{"purple", "Purple"},
		{"red", "Red"},
		{"santa1", "Santa Claus 1"},
		{"santa2", "Santa Claus 2"},
		{"snowflakesblue", "Snowflakes Blue"},
		{"snowflakespurple", "Snowflakes Purple"},
		{"snowflakesred", "Snowflakes Red"},
		{"snowman", "Snowman"},
		{"socks", "Socks"},
		{"starsblue", "Stars Blue"},
		{"starsgreen", "Stars Green"},
		{"starspurple", "Stars Purple"},
		{"starspurple2", "Stars Purple 2"},
		{"starsred", "Stars Red"},
		{"starsred2", "Stars Red 2"},
		{"treeblue", "Tree Blue"},
		{"treegreen", "Tree Green"},
		{"white", "White"},
		{"yellow", "Yellow"}
}

for _, row in ipairs(colours) do

	local name = row[1]
	local description = row[2]

	minetest.register_node("colouredstonebricks:"..name, {
		description = description.." Stone Brick",
		tiles = {"colouredstonebricks_"..name..".png"},
		groups = {cracky=3},
		on_rotate = screwdriver.rotate_simple,
		paramtype2 = "facedir",
        sounds = default.node_sound_stone_defaults(),
	})

	minetest.register_craft({
		type = "shapeless",
		output = 'colouredstonebricks:'..name,
		recipe = {
			'dye:'..name, 'default:stonebrick',
		}
	})

    -- Support for stairsplus mod
	if minetest.get_modpath("moreblocks") then
	    stairsplus:register_all("colouredstonebricks", name, "colouredstonebricks:"..name, {
	        description = description.." Stone Brick",
			tiles = {"colouredstonebricks_"..name..".png"},
			groups = {cracky=3},
			sounds = default.node_sound_stone_defaults(),
	        sunlight_propagates = true,
	    })
	end
end

-- We don't have blue, violet or magenta coloured stone bricks (yet)
--minetest.register_alias("dye:dark_blue","dye:blue")
--minetest.register_alias("dye:dark_pink","dye:magenta")
--minetest.register_alias("dye:purple","dye:violet")
